<?php
/**
 * FieldGetPointcut.class
 * 
 * @package aowp.aspect.pointcut
 */
class AOWP_FieldGetPointcut extends AOWP_PointcutComponent {
    private $_className;
    private $_fieldName;
	
	/**
	 * Constructor.
	 */
    public function __construct($className, $fieldName) 
    {
    	parent::__construct();
    	$this->_className = $className;
    	$this->_fieldName = $fieldName;
    }
   
    public function specificMatch(AOWP_JoinPoint $joinPoint)
    {    	
    	return 
    	( 
    		get_class($joinPoint)==AOWP_FieldGetJoinPoint) &&
    		AOWP_PointcutMatcher::match($this->_fieldName, $joinPoint->getFieldName()
    	);
    }

	public function runtimeSpecificMatch(AOWP_Context $context) 
	{
		return AOWP_PointcutMatcher::match($this->_className, get_class($context->instance));
	}
}
?>